package de.unirostock.Bridge.Schlange;

public class EinfachVerketteteSchlange implements AbstrSchlangeImplementierer{
	
	private EVSElement kopf;
	private EVSElement ende;
	private int anzahl;
	static int max = 6;
	
	// Konstruktoren
	public EinfachVerketteteSchlange() {
		kopf = null;
		ende = null;
		anzahl = 0;
	}
	
	public EinfachVerketteteSchlange(char w){
		kopf = new EVSElement(w);
		ende = kopf;
		anzahl = 1;
	}
	
	// Einfgeoperation
	public void insertElement(char w){
		EVSElement neu = new EVSElement(w);
		if (isEmpty()) {
			kopf = neu;
			ende = neu;
			anzahl = anzahl + 1;
		} else if (isFull()) {
				System.out.println("Die Schlange ist voll.");
			} else {
				ende.setNachfolger(neu);
				ende = neu;
				anzahl = anzahl + 1;
		}
	}
	
	// Lschoperation
	public void removeElement(){
		if (! isEmpty()) {
			kopf = kopf.getNachfolger();
			anzahl = anzahl - 1;
		} else System.out.println("Die Schlange ist leer.");
	}
	
	// Liefert das erste Element in der Schlange zurck
	public char getFirstElement(){
		if (isEmpty()) {
			return '-';
		} else return kopf.getWert();
	}
	
	// Liefert das erste Element in der Schlange zurck und lscht es gleichzeitig
	// Wird verwendet, um die Elemente der Schlange in einer anderen Schlange einzufgen
	public char getAndRemoveElement(){
		if (isEmpty()) {
			return '-';
		} else {
			char wert = kopf.getWert();
			removeElement();
			return wert;
		}
	}
	
	public boolean isEmpty() {
		if (anzahl == 0) {
			return true;
		} else return false;
	}
	public boolean isFull() {
		if (anzahl < max) {
			return false;
		} else return true;
	}
	
	public int getAnzahl() {
		return anzahl;
	}
	public char[] getAsArray() {
		char[] result = new char[max];
		EVSElement help = null;
		help = kopf;
		for (int i = 0; i < anzahl; i++) {
			result[i] = help.getWert();
			help = help.getNachfolger();
		}
		return result;
	}
}