package de.unirostock.Bridge.Schlange;

public class RingspeicherSchlange implements AbstrSchlangeImplementierer{
	
	private char[] speicher;
	private int kopf;
	private int ende;
	private int anzahl;
	static int max = 6;
	
	// Konstruktoren
	public RingspeicherSchlange() {
		kopf = 0;
		ende = 0;
		anzahl = 0;
		speicher = new char[max]; // Defaultwert der Aufnahmekapazitt
	}

	// Einfgeoperation
	public void insertElement(char w){
		if (isEmpty()) {
			speicher[kopf] = w;
			anzahl = anzahl + 1;
		} else {
			// Test, ob der Speicher voll ist
			if (!isFull()) {
				ende = this.getNextField(ende);
				speicher[ende] = w;			
				anzahl = anzahl + 1;
			} else System.out.println("Die Schlange ist voll.");
		}
	}
	
	// Lschoperation
	public void removeElement(){
		if (! isEmpty()) {
			speicher[kopf] = '-';
			if (anzahl > 1) {
				kopf = this.getNextField(kopf);
			}
			anzahl = anzahl - 1;
		} else System.out.println("Die Schlange ist leer.");
	}
	
	// Liefert das erste Element in der Schlange zurck
	public char getFirstElement(){
		if (isEmpty()) {
			return '-';
		} else return speicher[kopf];
	}
	
	// Liefert das erste Element in der Schlange zurck und lscht es gleichzeitig
	// Wird verwendet, um die Elemente der Schlange in einer anderen Schlange einzufgen
	public char getAndRemoveElement(){
		char wert = getFirstElement();
		removeElement();
		return wert;
	}
	
	// Next-Funktion, um die Ringstruktur zu realisieren
	private int getNextField(int x){
		if ((x == max - 1) || (x < 0) ) {
			return 0;
		} else return x + 1;
	}
	
	public boolean isEmpty() {
		if (anzahl == 0) {
			return true;
		} else return false;
	}
	public boolean isFull() {
		if (anzahl < max) {
			return false;
		} else return true;
	}
	public int getAnzahl() {
		return anzahl;
	}

	public char[] getAsArray() {
		char[] result = new char[max+1];
		result[0] = Integer.toString(kopf).charAt(0);
		int help = kopf;
		for (int i = 1; i <= anzahl; i++) {
			result[i] = speicher[help];
			help = getNextField(help);
		}
		return result;
	}
}