package de.unirostock.Bridge.Schlange.webapplet;

import java.awt.*;
import de.unirostock.Bridge.Schlange.*;

public class WebApp extends java.applet.Applet{

	static final long serialVersionUID = 1;
    Button press = new Button("Press");
	private GridBagConstraints constraints;
	private GridBagLayout gridbag;
	private AbstrSchlangeImplementierer s1, s2, s3;
	private KonkrSchlange schlange;
	private Label abbildungLabel, insertLabel;
	private CheckboxGroup g;
	private TextField textchar;
	private AbstrPaintSchlange paintedSchlange;

	public void init() 
		{
		setBackground(Color.WHITE);
		this.setSize(1000,260);
		gridbag = new GridBagLayout();
	    constraints = new GridBagConstraints();
	    setLayout(gridbag);
	    constraints.fill = GridBagConstraints.CENTER;
	    
	    g = new CheckboxGroup();
	    Checkbox i1 = new Checkbox("Einfach verkettete Schlange", g, true);
	    buildConstraints(constraints, 0, 0, 1, 1, 100, 100);//150
	    gridbag.setConstraints(i1, constraints);
	    add(i1);
	    
	    Checkbox i2 = new Checkbox("Doppelt verkettete Schlange", g, true);
	    buildConstraints(constraints, 1, 0, 1, 1, 100, 100);
	    gridbag.setConstraints(i2, constraints);
	    add(i2);
	    
	    Checkbox i3 = new Checkbox("Schlange als Ringspeicher", g, true);
	    buildConstraints(constraints, 2, 0, 1, 1, 100, 100);
	    gridbag.setConstraints(i3, constraints);
	    add(i3);
	    
	    insertLabel = new Label("Bitte ein Zeichen eingeben:");
	    buildConstraints(constraints, 0, 1, 1, 1, 100, 100);//100
	    gridbag.setConstraints(insertLabel, constraints);
	    add(insertLabel);
	    
	    constraints.anchor = GridBagConstraints.NORTH;
	    textchar = new TextField(1);
	    buildConstraints(constraints, 0, 2, 1, 1, 100, 100);//200
	    gridbag.setConstraints(textchar, constraints);
	    add(textchar);
	    
	    constraints.anchor = GridBagConstraints.NORTH;
	    Button insert= new Button("insert");
	    buildConstraints(constraints, 0, 3, 1, 1, 100, 100);//400
	    gridbag.setConstraints(insert, constraints);
	    add(insert);
    
	    Button remove = new Button("remove");
	    buildConstraints(constraints, 2, 2, 1, 1, 100, 100);
	    gridbag.setConstraints(remove, constraints);
	    add(remove);

	    constraints.fill = GridBagConstraints.HORIZONTAL;
	    constraints.anchor = GridBagConstraints.NORTH;
	    abbildungLabel = new Label("");
	    buildConstraints(constraints, 1, 1, 1, 1, 100, 100);//200
	    gridbag.setConstraints(abbildungLabel, constraints);
	    add(abbildungLabel);
	    
	    s1 = new EinfachVerketteteSchlange();
		s2 = new DoppeltVerketteteSchlange();
		s3 = new RingspeicherSchlange();
		
		g.setSelectedCheckbox(i1);
		schlange = new KonkrSchlange(s1);
		paintedSchlange = PaintEinfVerkSchlange.getDefault(abbildungLabel, schlange);
		repaint();
	}  

    public void paint(Graphics g1) {
    	g1.setColor(new Color(0,0,0));
        drawPapierkorb(g1);
		g1.drawLine(50,55,950,55);
		g1.drawRoundRect(35, 0, 960, 259, 40, 40);
		paintedSchlange.paintSchlange(g1,0);
    }
    
    public static void drawPapierkorb(Graphics g1){
    	//g1.drawLine(x,y,x,y);
    	g1.drawLine(730,130,745,170);//linke Seite
    	g1.drawLine(780,130,765,170);//rechte Seite
    	g1.drawLine(745,170,765,170);
    	g1.drawOval(730,125,50,10);
    	g1.setColor(new Color(180,180,180));
    	g1.fillOval(730,125,50,10);
    	g1.setColor(new Color(0,0,0));
    }
    
    public boolean action(Event evt, Object arg){
    	if (evt.target instanceof Button) {
    		String l = (String) arg;
    		if (l.equals("insert")) {insertAction();}
    		else if (l.equals("remove")) {removeAction();}
    	} else if (evt.target instanceof Checkbox) {
    		checkboxAction();
    	}
    	return true;
    }
    
    public void insertAction(){
    	if (!schlange.isFull()) {
    		if (textchar.getText().length() == 1) {
    			char c = textchar.getText().charAt(0);
    			textchar.setText("");
    			insertLabel.setText("Bitte ein Zeichen eingeben:");
    			paintedSchlange.paintInsertAnimation(this.getGraphics(), c);
    			schlange.insertElement(c);
    			repaint();
    			
    		} else {
    			if (textchar.getText().length() > 1) {
    				insertLabel.setText("Nur ein Zeichen eingeben:");
    				textchar.setText("");
    			} else insertLabel.setText("Bitte ein Zeichen eingeben:");
    		}
    	}
    }
    
    public void removeAction(){
    	if (!schlange.isEmpty()) {
    		char removedElem = schlange.getAndRemoveElement();
    		paintedSchlange.paintRemoveAnimation(this.getGraphics(), removedElem);
    		repaint();
    	}
    }
        
    public void checkboxAction(){
    	if (g.getSelectedCheckbox().getLabel() == "Einfach verkettete Schlange") {
    		schlange.setSchlangeImplementierer(s1);
    		paintedSchlange = PaintEinfVerkSchlange.getDefault(abbildungLabel, schlange);
    	} else if (g.getSelectedCheckbox().getLabel() == "Doppelt verkettete Schlange") {
    		schlange.setSchlangeImplementierer(s2);
    		paintedSchlange = PaintDoppVerkSchlange.getDefault(abbildungLabel, schlange);
    	} else if (g.getSelectedCheckbox().getLabel() == "Schlange als Ringspeicher") {
    		schlange.setSchlangeImplementierer(s3);
    		paintedSchlange = PaintRingspeicherSchlange.getDefault(abbildungLabel, schlange);
    	}
    	repaint();
    }
    
    public void buildConstraints(GridBagConstraints gbc, int gx, int gy,
            int gw, int gh, int wx, int wy){
            gbc.gridx = gx;
            gbc.gridy = gy;
            gbc.gridwidth = gw;
            gbc.gridheight = gh;
            gbc.weightx = wx;
            gbc.weighty = wy;
    };

    public static void verzoegern(){
    	try {
    	Thread.sleep(70);
    	} catch (Exception e) {System.out.println(e.getMessage());}
    }
}